// ignore_for_file: unused_import, duplicate_import

import 'dart:async';
import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:flutter_conscent_plugin/Model/content_access_model.dart';
import 'package:flutter_conscent_plugin/conscent_methods.dart';
import 'package:get/get.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';

ScrollController scrollController = ScrollController();
double heights = 0;
double onScollDepth = 0;

class MyAppff extends StatelessWidget {
  const MyAppff({super.key});

  @override
  Widget build(BuildContext context) {
    const appTitle = 'Default Mode';

    return Scaffold(
      body: NestedScrollView(
        headerSliverBuilder: (context, innerBoxIsScrolled) {
          return [
            const SliverAppBar(
              expandedHeight: 10,
              backgroundColor: Color.fromRGBO(245, 194, 203, 1.0),
              title: Text(
                'Read article',
              ),
            ),
          ];
        },
        controller: scrollController,
        body: const DefaultSubState(),
      ),
    );
  }
}

class DefaultSubState extends StatefulWidget {
  const DefaultSubState();
  @override
  State<DefaultSubState> createState() => _DefaultSubStateState();
}

class _DefaultSubStateState extends State<DefaultSubState> {
  bool showContent = false;

  ConscentMethods conscentMethods = ConscentMethods();

  @override
  void initState() {
    super.initState();
    scrollController.addListener(() {
      onScollDepth = scrollController.offset;
      print('scrollController.offset  ${scrollController.offset}');
    });
  }

  @override
  void dispose() {
    super.dispose();
    conscentMethods.pageViewDisposeEvent(heights, onScollDepth);
  }

//API logout post
  @override
  Widget build(BuildContext context) {

    heights = MediaQuery.of(context).size.height;

    conscentMethods.pageViewEvent(heights, onScollDepth);
    return SafeArea(
      child: Scaffold(
          body: GestureDetector(
            onTap: () {
              ConscentMethods().onTapFun();
              ScaffoldMessenger.of(context).showSnackBar(const SnackBar(
                content: Text("onTap  called"),
              ));
            },
            child: FutureBuilder<ContentAccessModel?>(
              future: ConscentMethods().getContentAccess(),
              builder: (context, snapshot) {
                var responseData = snapshot.data;
                // print(responseData?.signature);
                if (snapshot.hasData) {
                  return Center(
                    child: Column(
                      children: [
                        responseData?.signature == null
                            ? Padding(
                          padding: const EdgeInsets.all(20.0),
                          child: Text(
                            'Early use Scientists are still debating when people started wearing clothes. Estimates by various experts have ranged from 40,000 to 3 million years ago. Some more recent studies involving the evolution of body lice have implied a more recent development with some indicating a development of around 170,000 years ago and others indicating as little as 40,000. No single estimate is widely accepted.[1][2][3][4] Ralf Kittler, Manfred Kayser and Mark Stoneking, anthropologists at the Max Planck Institute for Evolutionary Anthropology, conducted a genetic analysis of human body lice that suggests clothing originated around 170,000 years ago. Body lice are an indicator of clothes-wearing, since most humans have sparse body hair, and lice thus require human clothing to survive. Their research suggests that the invention of clothing may have coincided with the northward migration of modern Homo sapiens away from the warm climate of Africa, thought to have begun between 50,000 and 100,000 years ago. However, a second group of researchers using similar genetic methods estimate that clothing originated around 540,000 years ago.[5]...',
                            maxLines: showContent ? null : 4,
                          ),
                        )
                            : const SizedBox.shrink(),
                            showContent
                            ? Container()
                            : Expanded(
                            flex: 2,
                            // child: MyApppp((response)
                            child: responseData?.signature != null
                                ? const Center(
                              child: Text(
                                  'Early use Scientists are still debating when people started wearing clothes. Estimates by various experts have ranged from 40,000 to 3 million years ago. Some more recent studies involving the evolution of body lice have implied a more recent development with some indicating a development of around 170,000 years ago and others indicating as little as 40,000. No single estimate is widely accepted.[1][2][3][4] Ralf Kittler, Manfred Kayser and Mark Stoneking, anthropologists at the Max Planck Institute for Evolutionary Anthropology, conducted a genetic analysis of human body lice that suggests clothing originated around 170,000 years ago. Body lice are an indicator of clothes-wearing, since most humans have sparse body hair, and lice thus require human clothing to survive. Their research suggests that the invention of clothing may have coincided with the northward migration of modern Homo sapiens away from the warm climate of Africa, thought to have begun between 50,000 and 100,000 years ago. However, a second group of researchers using similar genetic methods estimate that clothing originated around 540,000 years ago.[5]...'),
                            ) : Paywall((response) {
                                  if (responseData != null &&
                                      responseData.signature != null) {
                                    showContent = true;
                                  } else {
                                    showContent = false;
                                  }
                                  setState(() {});

                                  (context as Element).reassemble();
                            })
                        ),
                      ],
                    ),
                  );
                } else if (snapshot.hasError) {
                  return const Text('error');
                } else {
                  return const SizedBox.shrink();
                }
              },
            ),
          )),
    );
  }
}
