import 'package:flutter/material.dart';
import '../../conscent_methods.dart';
import '../../constants.dart';
import '../../web_view_default.dart';
import '../flutter_flow/custom_functions.dart' as functions;
import '../flutter_flow/flutter_flow_theme.dart';
import '../flutter_flow/flutter_flow_util.dart';
import '../flutter_flow/flutter_flow_widgets.dart';

class InArticle50pageblock3A3CTAWidget extends StatefulWidget {
  Function(String) sessionCallback;
  InArticle50pageblock3A3CTAWidget(this.sessionCallback, {Key? key})
      : super(key: key);

  @override
  _InArticle50pageblock3A3CTAWidgetState createState() =>
      _InArticle50pageblock3A3CTAWidgetState();
}

class _InArticle50pageblock3A3CTAWidgetState
    extends State<InArticle50pageblock3A3CTAWidget> {
  final _unfocusNode = FocusNode();
  final scaffoldKey = GlobalKey<ScaffoldState>();
  List<String> typeOfPurchase = ["subscription", ""];
  bool isContentButton = false;
  bool isPassButton = false;
  bool isSubscribeButton = true;
  final paywallconfigResponse = Constants.paywallConfig;

  @override
  void initState() {
    ConscentMethods().paywallViewEvent();
    typeOfPurchase[0] = (paywallconfigResponse
        .data
        ?.configuration
        ?.mobile
        ?.json
        ?.slotData
        ?.slot
        ?.contentDivBtn
        ?.value ??
        "");
    typeOfPurchase[1] =
    (paywallconfigResponse
        .data
        ?.configuration
        ?.mobile
        ?.json
        ?.slotData
        ?.slot
        ?.contentDivBtn
        ?.url ??
        "");
    super.initState();
  }

  @override
  void dispose() {
    _unfocusNode.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      key: scaffoldKey,
      backgroundColor: FlutterFlowTheme.of(context).primaryBackground,
      body: SafeArea(
        child: GestureDetector(
          onTap: () => FocusScope.of(context).requestFocus(_unfocusNode),
          child: Align(
              alignment: AlignmentDirectional(0, 1),
              child: Container(
                width: MediaQuery.of(context).size.width,
                height: MediaQuery.of(context).size.height * 0.5,
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(valueOrDefault<double>(
                    paywallconfigResponse.data?.configuration?.mobile?.json
                        ?.styleForBackground?.border?.mainDiv?.radius
                        ?.toDouble(),
                    0,
                  )),
                  border: Border.all(
                    color: colorFromCssString(valueOrDefault<String>(
                      paywallconfigResponse.data?.configuration?.mobile?.json
                          ?.styleForBackground?.border?.mainDiv?.borderColor,
                      '#000000',
                    )),
                    width: valueOrDefault<double>(
                      paywallconfigResponse
                          .data
                          ?.configuration
                          ?.mobile
                          ?.json
                          ?.styleForBackground
                          ?.border
                          ?.mainDiv
                          ?.borderWidthValue
                          ?.toDouble(),
                      0,
                    ),
                  ),
                  color: colorFromCssString(valueOrDefault<String>(
                    paywallconfigResponse.data?.configuration?.mobile?.json
                        ?.styleForBackground?.border?.mainDiv?.backgroundColor,
                    '#000000',
                  )),
                ),
                child: Padding(
                  padding: EdgeInsetsDirectional.fromSTEB(28, 20, 28, 12),
                  child: SingleChildScrollView(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      children: [
                        Column(
                          mainAxisSize: MainAxisSize.max,
                          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                          children: [
                            Text(
                              getTextWithTransform(
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForText
                                      ?.typography
                                      ?.heading
                                      ?.text,
                                  'Don’t miss out on the full story',
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForText
                                      ?.typography
                                      ?.heading
                                      ?.textTransform),
                              textAlign: getTextAlign(valueOrDefault<String>(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.heading
                                    ?.textAlign,
                                '',
                              )),
                              style: FlutterFlowTheme.of(context)
                                  .bodyText1
                                  .override(
                                    fontFamily: valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.heading
                                          ?.fontFamily,
                                      'Playfair Display',
                                    ),
                                    color: colorFromCssString(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.heading
                                          ?.color,
                                      '#ffffff',
                                    )),
                                    decoration: getTextDecoration(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.heading
                                          ?.textDecoration,
                                      "",
                                    )),
                                    fontSize: 22,
                                    fontWeight:
                                        getFontWeight(valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.heading

                                          ?.fontWeight,
                                      "",
                                    )),
                                  ),
                            ),
                            Padding(
                                padding: EdgeInsetsDirectional.fromSTEB(
                                    12, 12, 12, 0),
                                child: Text(
                                  getTextWithTransform(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.subHeading
                                          ?.text,
                                      'Subscribe for unlimited, uninterrupted and easy digital access',
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.subHeading
                                          ?.textTransform),
                                  textAlign:
                                      getTextAlign(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.subHeading
                                        ?.textAlign,
                                    '',
                                  )),
                                  style: FlutterFlowTheme.of(context)
                                      .bodyText1
                                      .override(
                                        fontFamily: valueOrDefault<String>(
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.subHeading
                                              ?.fontFamily,
                                          'Roboto',
                                        ),
                                        color: colorFromCssString(
                                            valueOrDefault<String>(
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.subHeading
                                              ?.color,
                                          '#ffffff',
                                        )),
                                        decoration: getTextDecoration(
                                            valueOrDefault<String>(
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.subHeading
                                              ?.textDecoration,
                                          "",
                                        )),
                                        fontSize: 12,
                                        fontWeight: getFontWeight(
                                            valueOrDefault<String>(
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.subHeading
                                              ?.fontWeight,
                                          "",
                                        )),
                                        lineHeight: 2,
                                      ),
                                )),
                          ],
                        ),
                        Padding(
                            padding:
                                EdgeInsetsDirectional.fromSTEB(0, 12, 0, 0),
                            child: Column(
                              mainAxisSize: MainAxisSize.min,
                              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                              children: [
                                Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0, 0, 0, 5),
                                  child: Row(
                                    mainAxisSize: MainAxisSize.min,
                                    mainAxisAlignment:
                                        MainAxisAlignment.spaceEvenly,
                                    children: [
                                      Padding(
                                          padding:
                                              EdgeInsetsDirectional.fromSTEB(
                                                  0, 0, 10, 0),
                                          child: InkWell(
                                              onTap: () {
                                                typeOfPurchase[0] =
                                                    (paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.slotData
                                                            ?.slot
                                                            ?.contentDivBtn
                                                            ?.value ??
                                                        "");
                                                typeOfPurchase[1] =
                                                    (paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.slotData
                                                            ?.slot
                                                            ?.contentDivBtn
                                                            ?.url ??
                                                        "");
                                                print("typeOfPurchase = SUBS");
                                                isContentButton = false;
                                                isPassButton = false;
                                                isSubscribeButton = true;
                                                setState(() {});
                                              },
                                              child: Container(
                                                width: MediaQuery.of(context)
                                                        .size
                                                        .width *
                                                    0.35,
                                                height: MediaQuery.of(context)
                                                    .size
                                                    .height,
                                                constraints:
                                                    const BoxConstraints(
                                                  maxHeight: 100,
                                                ),
                                                decoration: BoxDecoration(
                                                  color: colorFromCssString(
                                                      valueOrDefault<String>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.contentDivBtn
                                                        ?.backgroundColor,
                                                    '#232323',
                                                  )),
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          valueOrDefault<
                                                              double>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.contentDivBtn
                                                        ?.radius
                                                        ?.toDouble(),
                                                    0,
                                                  )),
                                                  border: isSubscribeButton
                                                      ? Border.all(
                                                          color: Colors.blue,
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        )
                                                      : Border.all(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentDivBtn
                                                                ?.borderColor,
                                                            '#ffffff',
                                                          )),
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        ),
                                                ),
                                                child: Align(
                                                  alignment:
                                                      AlignmentDirectional(
                                                          0, 0),
                                                  child: Column(
                                                    mainAxisSize:
                                                        MainAxisSize.min,
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .center,
                                                    children: [
                                                      Text(
                                                        getTextWithTransform(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.contentDivTitle
                                                                ?.text,
                                                            'Weekly Micropayment',
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.contentDivTitle
                                                                ?.textTransform),
                                                        textAlign:
                                                            TextAlign.center,
                                                        style:
                                                            FlutterFlowTheme.of(
                                                                    context)
                                                                .bodyText1
                                                                .override(
                                                                  fontFamily:
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivTitle
                                                                        ?.fontFamily,
                                                                    'Roboto',
                                                                  ),
                                                                  color: colorFromCssString(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivTitle
                                                                        ?.color,
                                                                    '#0056d6',
                                                                  )),
                                                                  decoration: getTextDecoration(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivTitle
                                                                        ?.textDecoration,
                                                                    "",
                                                                  )),
                                                                  fontSize: 16,
                                                                  fontWeight: getFontWeight(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivTitle
                                                                        ?.fontWeight,
                                                                    "700",
                                                                  )),
                                                                ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            const EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                0, 5, 0, 0),
                                                        child: Text(
                                                          getTextWithTransform(
                                                              "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.contentDivPrice?.text} ${Constants.contentPrice}",
                                                              'RS 999',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.contentDivPrice
                                                                  ?.textTransform),
                                                          textAlign:
                                                              TextAlign.center,
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivPrice
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivPrice
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivPrice
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 16,
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivPrice
                                                                      ?.fontWeight,
                                                                  "700",
                                                                )),
                                                              ),
                                                        ),
                                                      ),
                                                    ],
                                                  ),
                                                ),
                                              ))),
                                      if (paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.templateId
                                                  ?.numberOfCta ==
                                              2 ||
                                          paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.templateId
                                                  ?.numberOfCta ==
                                              3)
                                        Padding(
                                            padding:
                                                EdgeInsetsDirectional.fromSTEB(
                                                    0, 0, 0, 0),
                                            child: InkWell(
                                                onTap: () async {
                                                  typeOfPurchase[0] =
                                                      (paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.slotData
                                                              ?.slot
                                                              ?.passDivBtn
                                                              ?.value ??
                                                          "");
                                                  typeOfPurchase[1] =
                                                      (paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.slotData
                                                              ?.slot
                                                              ?.passDivBtn
                                                              ?.url ??
                                                          "");
                                                  isContentButton = false;
                                                  isPassButton = true;
                                                  isSubscribeButton = false;
                                                  setState(() {});
                                                },
                                                child: Container(
                                                  width: MediaQuery.of(context)
                                                          .size
                                                          .width *
                                                      0.35,
                                                  height: MediaQuery.of(context)
                                                      .size
                                                      .height,
                                                  constraints:
                                                      const BoxConstraints(
                                                    maxHeight: 100,
                                                  ),
                                                  decoration: BoxDecoration(
                                                    color: colorFromCssString(
                                                        valueOrDefault<String>(
                                                      paywallconfigResponse
                                                          .data
                                                          ?.configuration
                                                          ?.mobile
                                                          ?.json
                                                          ?.styleForBackground
                                                          ?.border
                                                          ?.passDivBtn
                                                          ?.backgroundColor,
                                                      '#232323',
                                                    )),
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            valueOrDefault<
                                                                double>(
                                                      paywallconfigResponse
                                                          .data
                                                          ?.configuration
                                                          ?.mobile
                                                          ?.json
                                                          ?.styleForBackground
                                                          ?.border
                                                          ?.passDivBtn
                                                          ?.radius
                                                          ?.toDouble(),
                                                      0,
                                                    )),
                                                    border: isPassButton
                                                        ? Border.all(
                                                            color: Colors.blue,
                                                            width:
                                                                valueOrDefault<
                                                                    double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passDivBtn
                                                                  ?.borderWidthValue
                                                                  ?.toDouble(),
                                                              0,
                                                            ),
                                                          )
                                                        : Border.all(
                                                            color: colorFromCssString(
                                                                valueOrDefault<
                                                                    String>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passDivBtn
                                                                  ?.borderColor,
                                                              '#ffffff',
                                                            )),
                                                            width:
                                                                valueOrDefault<
                                                                    double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passDivBtn
                                                                  ?.borderWidthValue
                                                                  ?.toDouble(),
                                                              0,
                                                            ),
                                                          ),
                                                  ),
                                                  child: Align(
                                                    alignment:
                                                        AlignmentDirectional(
                                                            0, 0),
                                                    child: Column(
                                                      mainAxisSize:
                                                          MainAxisSize.min,
                                                      mainAxisAlignment:
                                                          MainAxisAlignment
                                                              .center,
                                                      children: [
                                                        Text(
                                                          getTextWithTransform(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.passDivTitle
                                                                  ?.text,
                                                              'Weekly Pass',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.passDivTitle
                                                                  ?.textTransform),
                                                          textAlign:
                                                              TextAlign.center,
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivTitle
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivTitle
                                                                      ?.color,
                                                                  '#0056d6',
                                                                )),
                                                                fontSize: 16,
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivTitle
                                                                      ?.fontWeight,
                                                                  "700",
                                                                )),
                                                              ),
                                                        ),
                                                        Padding(
                                                          padding:
                                                              const EdgeInsetsDirectional
                                                                      .fromSTEB(
                                                                  0, 5, 0, 0),
                                                          child: Text(
                                                            getTextWithTransform(
                                                                "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.passDivPrice?.text} ${Constants.passPrice}",
                                                                'RS 999',
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.passDivPrice
                                                                    ?.textTransform),
                                                            textAlign: TextAlign
                                                                .center,
                                                            style: FlutterFlowTheme
                                                                    .of(context)
                                                                .bodyText1
                                                                .override(
                                                                  fontFamily:
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivPrice
                                                                        ?.fontFamily,
                                                                    'Roboto',
                                                                  ),
                                                                  color: colorFromCssString(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivPrice
                                                                        ?.color,
                                                                    '#ffffff',
                                                                  )),
                                                                  fontSize: 16,
                                                                  decoration: getTextDecoration(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivPrice
                                                                        ?.textDecoration,
                                                                    "",
                                                                  )),
                                                                  fontWeight: getFontWeight(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivPrice
                                                                        ?.fontWeight,
                                                                    "700",
                                                                  )),
                                                                ),
                                                          ),
                                                        ),
                                                      ],
                                                    ),
                                                  ),
                                                ))),
                                    ],
                                  ),
                                ),
                                if (paywallconfigResponse.data?.configuration
                                        ?.mobile?.templateId?.numberOfCta ==
                                    3)
                                  Padding(
                                      padding: EdgeInsetsDirectional.fromSTEB(
                                          0, 5, 0, 0),
                                      child: InkWell(
                                          onTap: () async {
                                            typeOfPurchase[0] =
                                                (paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.slotData
                                                        ?.slot
                                                        ?.subDivBtn
                                                        ?.value ??
                                                    "");
                                            typeOfPurchase[1] =
                                                (paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.slotData
                                                        ?.slot
                                                        ?.subDivBtn
                                                        ?.url ??
                                                    "");
                                            isContentButton = true;
                                            isPassButton = false;
                                            isSubscribeButton = false;
                                            setState(() {});
                                          },
                                          child: Container(
                                            width: MediaQuery.of(context)
                                                    .size
                                                    .width *
                                                0.4,
                                            height: MediaQuery.of(context)
                                                .size
                                                .height,
                                            constraints: const BoxConstraints(
                                              maxHeight: 100,
                                            ),
                                            decoration: BoxDecoration(
                                              color: colorFromCssString(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForBackground
                                                    ?.border
                                                    ?.subDivBtn
                                                    ?.backgroundColor,
                                                '#232323',
                                              )),
                                              borderRadius:
                                                  BorderRadius.circular(
                                                      valueOrDefault<double>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForBackground
                                                    ?.border
                                                    ?.subDivBtn
                                                    ?.radius
                                                    ?.toDouble(),
                                                0,
                                              )),
                                              border: isContentButton
                                                  ? Border.all(
                                                      color: Colors.blue,
                                                      width: valueOrDefault<
                                                          double>(
                                                        paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.styleForBackground
                                                            ?.border
                                                            ?.subDivBtn
                                                            ?.borderWidthValue
                                                            ?.toDouble(),
                                                        0,
                                                      ),
                                                    )
                                                  : Border.all(
                                                      color: colorFromCssString(
                                                          valueOrDefault<
                                                              String>(
                                                        paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.styleForBackground
                                                            ?.border
                                                            ?.subDivBtn
                                                            ?.borderColor,
                                                        '#ffffff',
                                                      )),
                                                      width: valueOrDefault<
                                                          double>(
                                                        paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.styleForBackground
                                                            ?.border
                                                            ?.subDivBtn
                                                            ?.borderWidthValue
                                                            ?.toDouble(),
                                                        0,
                                                      ),
                                                    ),
                                            ),
                                            child: Align(
                                              alignment:
                                                  AlignmentDirectional(0, 0),
                                              child: Column(
                                                mainAxisSize: MainAxisSize.min,
                                                mainAxisAlignment:
                                                    MainAxisAlignment.center,
                                                children: [
                                                  Text(
                                                    getTextWithTransform(
                                                        paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.styleForText
                                                            ?.typography
                                                            ?.subDivTitle
                                                            ?.text,
                                                        'Subscription',
                                                        paywallconfigResponse
                                                            .data
                                                            ?.configuration
                                                            ?.mobile
                                                            ?.json
                                                            ?.styleForText
                                                            ?.typography
                                                            ?.subDivTitle
                                                            ?.textTransform),
                                                    textAlign: TextAlign.center,
                                                    style: FlutterFlowTheme.of(
                                                            context)
                                                        .bodyText1
                                                        .override(
                                                          fontFamily:
                                                              valueOrDefault<
                                                                  String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivTitle
                                                                ?.fontFamily,
                                                            'Roboto',
                                                          ),
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivTitle
                                                                ?.color,
                                                            '#0056d6',
                                                          )),
                                                          fontSize: 16,
                                                          decoration:
                                                              getTextDecoration(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivTitle
                                                                ?.textDecoration,
                                                            "",
                                                          )),
                                                          fontWeight:
                                                              getFontWeight(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivTitle
                                                                ?.fontWeight,
                                                            "700",
                                                          )),
                                                        ),
                                                  ),
                                                  Padding(
                                                    padding:
                                                        EdgeInsetsDirectional
                                                            .fromSTEB(
                                                                0, 5, 0, 0),
                                                    child: Text(
                                                      getTextWithTransform(
                                                          "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.subDivPrice?.text} ${Constants.subscriptionPrice}",
                                                          'RS 999',
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForText
                                                              ?.typography
                                                              ?.subDivPrice
                                                              ?.textTransform),
                                                      textAlign:
                                                          TextAlign.center,
                                                      style:
                                                          FlutterFlowTheme.of(
                                                                  context)
                                                              .bodyText1
                                                              .override(
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 16,
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.fontWeight,
                                                                  "700",
                                                                )),
                                                              ),
                                                    ),
                                                  ),
                                                ],
                                              ),
                                            ),
                                          ))),
                              ],
                            )),
                        if (functions.conscentBalanceVisibilty())
                          Padding(
                            padding: const EdgeInsetsDirectional.fromSTEB(
                                0, 30, 0, 0),
                            child: Text(
                              getTextWithTransform(
                                  'ConsCent Balance: ₹${Constants.conscentBalance}',
                                  "ConsCent Balance: ₹0",
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForText
                                      ?.typography
                                      ?.conscentBalance
                                      ?.textTransform),
                              style: FlutterFlowTheme.of(context)
                                  .bodyText1
                                  .override(
                                    fontFamily: valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.conscentBalance
                                          ?.fontFamily,
                                      'Roboto',
                                    ),
                                    color: colorFromCssString(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.conscentBalance
                                          ?.color,
                                      '#ffffff',
                                    )),
                                    decoration: getTextDecoration(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.conscentBalance
                                          ?.textDecoration,
                                      "",
                                    )),
                                    fontWeight:
                                        getFontWeight(valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.conscentBalance
                                          ?.fontWeight,
                                      "600",
                                    )),
                                  ),
                            ),
                          ),
                        Padding(
                          padding:
                              const EdgeInsetsDirectional.fromSTEB(0, 30, 0, 10),
                          child: FFButtonWidget(
                            onPressed: () async {
                              print('Button pressed ...');
                              print(
                                  "typeOfPurchase ${typeOfPurchase.first} ${typeOfPurchase.last}");
                              String redirectUrl = await ConscentMethods()
                                  .prepareLoginChallenge(typeOfPurchase);

                              if (typeOfPurchase[0] == "subscription") {
                                ConscentMethods().paywallClickEvent("SUBS");
                              } else {
                                if (typeOfPurchase[0] == "" ||
                                    typeOfPurchase[0] == null) {
                                  ConscentMethods()
                                      .paywallClickEvent("CONTENT");
                                } else {
                                  ConscentMethods().paywallClickEvent(
                                      typeOfPurchase[0].toUpperCase());
                                }
                              }

                              Navigator.push(
                                  context,
                                  MaterialPageRoute(
                                    builder: (context) => WebViewDefaultApp(
                                        redirectUrl: redirectUrl),
                                  )).then((value) {
                                if (value != null) {
                                  dynamic response = value['response'];
                                  widget.sessionCallback(response);
                                }
                              });
                            },
                            text: getTextWithTransform(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.mainSubmitBtn
                                    ?.text,
                                'Subscribe',
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.mainSubmitBtn
                                    ?.textTransform),
                            options: FFButtonOptions(
                              width: 346.5,
                              height: 59.7,
                              color: colorFromCssString(valueOrDefault<String>(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForBackground
                                    ?.border
                                    ?.mainSubmitBtn
                                    ?.backgroundColor,
                                '#0164B1',
                              )),
                              textStyle: FlutterFlowTheme.of(context)
                                  .subtitle2
                                  .override(
                                    fontFamily: valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.mainSubmitBtn
                                          ?.fontFamily,
                                      'Roboto',
                                    ),
                                    decoration: getTextDecoration(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.mainSubmitBtn
                                          ?.textDecoration,
                                      "",
                                    )),
                                    color: colorFromCssString(
                                        valueOrDefault<String>(
                                      paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.styleForText
                                          ?.typography
                                          ?.mainSubmitBtn
                                          ?.color,
                                      '#ffffff',
                                    )),
                                  ),
                              borderSide: BorderSide(
                                color:
                                    colorFromCssString(valueOrDefault<String>(
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForBackground
                                      ?.border
                                      ?.mainSubmitBtn
                                      ?.borderColor,
                                  '#0164B1',
                                )),
                                width: valueOrDefault<double>(
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForBackground
                                      ?.border
                                      ?.mainSubmitBtn
                                      ?.borderWidthValue
                                      ?.toDouble(),
                                  0,
                                ),
                              ),
                              borderRadius:
                                  BorderRadius.circular(valueOrDefault<double>(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForBackground
                                    ?.border
                                    ?.mainSubmitBtn
                                    ?.radius
                                    ?.toDouble(),
                                0,
                              )),
                            ),
                          ),
                        ),
                        Align(
                          alignment: AlignmentDirectional(-0.05, 0),
                          child: Padding(
                            padding:
                                EdgeInsetsDirectional.fromSTEB(0, 10, 0, 20),
                            child: Column(
                              mainAxisSize: MainAxisSize.max,
                              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                              children: [

                                Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0, 10, 0, 0),
                                  child: Row(
                                    mainAxisSize: MainAxisSize.max,
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    children: [
                                      Text(
                                        getTextWithTransform(
                                            'Already Purchased? ',
                                            'Already Purchased? ',
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.alreadyLeftText
                                                ?.textTransform),
                                        style: FlutterFlowTheme.of(context)
                                            .bodyText1
                                            .override(
                                              fontFamily:
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.alreadyLeftText
                                                    ?.fontFamily,
                                                'Roboto',
                                              ),
                                              color: colorFromCssString(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.alreadyLeftText
                                                    ?.color,
                                                '#ffffff',
                                              )),
                                              fontWeight: getFontWeight(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.alreadyLeftText
                                                    ?.fontWeight,
                                                "",
                                              )),
                                              decoration: getTextDecoration(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.alreadyLeftText
                                                    ?.textDecoration,
                                                "",
                                              )),
                                            ),
                                      ),
                                      InkWell(
                                        onTap: () async {

                                          typeOfPurchase.first = "";
                                          String redirectUrl =
                                              await ConscentMethods()
                                                  .prepareLoginChallenge(
                                                      typeOfPurchase);
                                          if (typeOfPurchase[0] ==
                                              "subscription") {
                                            ConscentMethods()
                                                .paywallClickEvent("SUBS");
                                          } else {
                                            ConscentMethods().paywallClickEvent(
                                                typeOfPurchase[0]
                                                    .toUpperCase());
                                          }
                                          Navigator.push(
                                              context,
                                              MaterialPageRoute(
                                                builder: (context) =>
                                                    WebViewDefaultApp(
                                                        redirectUrl:
                                                            redirectUrl),
                                              )).then((value) {
                                            if (value != null) {
                                              dynamic response =
                                                  value['response'];
                                              widget.sessionCallback(response);
                                            }
                                          });
                                        },
                                        child: Text(
                                          getTextWithTransform(
                                              'Login',
                                              'Login',
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.loginText
                                                  ?.textTransform),
                                          style: FlutterFlowTheme.of(context)
                                              .bodyText1
                                              .override(
                                                fontFamily:
                                                    valueOrDefault<String>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForText
                                                      ?.typography
                                                      ?.loginText
                                                      ?.fontFamily,
                                                  'Roboto',
                                                ),
                                                color: colorFromCssString(
                                                    valueOrDefault<String>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForText
                                                      ?.typography
                                                      ?.loginText
                                                      ?.color,
                                                  '#ffffff',
                                                )),
                                                fontWeight: getFontWeight(
                                                    valueOrDefault<String>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForText
                                                      ?.typography
                                                      ?.loginText
                                                      ?.fontWeight,
                                                  "500",
                                                )),
                                                decoration: getTextDecoration(
                                                    valueOrDefault<String>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForText
                                                      ?.typography
                                                      ?.loginText
                                                      ?.textDecoration,
                                                  "",
                                                )),
                                              ),
                                        ),
                                      )
                                    ],
                                  ),
                                ),
                              ],
                            ),
                          ),
                        ),
                      ],
                    ),
                  ),
                ),
              )),
        ),
      ),
    );
  }
}
