import 'package:flutter/material.dart';
import '../../conscent_methods.dart';
import '../../constants.dart';
import '../../Model/paywall_config.dart';
import '../../web_view_default.dart';
import '../flutter_flow/custom_functions.dart' as functions;
import '../flutter_flow/flutter_flow_theme.dart';
import '../flutter_flow/flutter_flow_util.dart';
import '../flutter_flow/flutter_flow_widgets.dart';
import 'package:auto_size_text/auto_size_text.dart';

class Inarticle5A3CTAWidget extends StatefulWidget {
  Function(String) sessionCallback;
  Inarticle5A3CTAWidget(this.sessionCallback, {Key? key}) : super(key: key);

  @override
  _Inarticle5A3CTAWidgetState createState() => _Inarticle5A3CTAWidgetState();
}

class _Inarticle5A3CTAWidgetState extends State<Inarticle5A3CTAWidget> {
  final scaffoldKey = GlobalKey<ScaffoldState>();
  final _unfocusNode = FocusNode();
  List<String> typeOfPurchase = ["subscription", ""];
  bool isContentButton = false;
  bool isPassButton = false;
  bool isSubscribeButton = true;

  @override
  void initState() {
    ConscentMethods().paywallViewEvent();
    super.initState();
  }

  @override
  void dispose() {
    _unfocusNode.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    PaywallConfig paywallconfigResponse = Constants.paywallConfig;

    return Scaffold(
      key: scaffoldKey,
      backgroundColor: FlutterFlowTheme.of(context).primaryBackground,
      body: SafeArea(
        child: GestureDetector(
          onTap: () => FocusScope.of(context).requestFocus(_unfocusNode),
          child: Align(
            alignment: AlignmentDirectional(0, 1),
            child: Container(
              width: MediaQuery.of(context).size.width,
              height: MediaQuery.of(context).size.height * 0.8,
              decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(valueOrDefault<double>(
                  paywallconfigResponse.data?.configuration?.mobile?.json
                      ?.styleForBackground?.border?.mainDiv?.radius
                      ?.toDouble(),
                  0,
                )),
                border: Border.all(
                  color: colorFromCssString(valueOrDefault<String>(
                    paywallconfigResponse.data?.configuration?.mobile?.json
                        ?.styleForBackground?.border?.mainDiv?.borderColor,
                    '#000000',
                  )),
                  width: valueOrDefault<double>(
                    paywallconfigResponse.data?.configuration?.mobile?.json
                        ?.styleForBackground?.border?.mainDiv?.borderWidthValue
                        ?.toDouble(),
                    0,
                  ),
                ),
                color: colorFromCssString(valueOrDefault<String>(
                  paywallconfigResponse.data?.configuration?.mobile?.json
                      ?.styleForBackground?.border?.mainDiv?.backgroundColor,
                  '#000000',
                )),
              ),
              child: Padding(
                padding: EdgeInsetsDirectional.fromSTEB(28, 50, 28, 50),
                child: SingleChildScrollView(
                  child: Column(
                    mainAxisSize: MainAxisSize.max,
                    children: [
                      Column(
                        mainAxisSize: MainAxisSize.max,
                        children: [
                          Text(
                            getTextWithTransform(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.heading
                                    ?.text,
                                'Don’t miss out on the full story',
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.heading
                                    ?.textTransform),
                            textAlign: getTextAlign(valueOrDefault<String>(
                              paywallconfigResponse
                                  .data
                                  ?.configuration
                                  ?.mobile
                                  ?.json
                                  ?.styleForText
                                  ?.typography
                                  ?.heading
                                  ?.textAlign,
                              '',
                            )),
                            style: FlutterFlowTheme.of(context)
                                .bodyText1
                                .override(
                                  fontFamily: valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.heading
                                        ?.fontFamily,
                                    'Playfair Display',
                                  ),
                                  color:
                                      colorFromCssString(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.heading
                                        ?.color,
                                    '#ffffff',
                                  )),
                                  fontSize: 22,
                                  fontWeight:
                                      getFontWeight(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.heading
                                        ?.fontWeight,
                                    "",
                                  )),
                                  decoration:
                                      getTextDecoration(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.heading
                                        ?.textDecoration,
                                    "",
                                  )),
                                ),
                          ),
                          Padding(
                              padding:
                                  EdgeInsetsDirectional.fromSTEB(12, 12, 12, 0),
                              child: Text(
                                getTextWithTransform(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.subHeading
                                        ?.text,
                                    'Subscribe for unlimited, uninterrupted and easy digital access',
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.subHeading
                                        ?.textTransform),
                                textAlign: getTextAlign(valueOrDefault<String>(
                                  paywallconfigResponse
                                      .data
                                      ?.configuration
                                      ?.mobile
                                      ?.json
                                      ?.styleForText
                                      ?.typography
                                      ?.subHeading
                                      ?.textAlign,
                                  '',
                                )),
                                style: FlutterFlowTheme.of(context)
                                    .bodyText1
                                    .override(
                                      fontFamily: valueOrDefault<String>(
                                        paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.styleForText
                                            ?.typography
                                            ?.subHeading
                                            ?.fontFamily,
                                        'Roboto',
                                      ),
                                      color: colorFromCssString(
                                          valueOrDefault<String>(
                                        paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.styleForText
                                            ?.typography
                                            ?.subHeading
                                            ?.color,
                                        '#ffffff',
                                      )),
                                      fontSize: 12,
                                      fontWeight:
                                          getFontWeight(valueOrDefault<String>(
                                        paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.styleForText
                                            ?.typography
                                            ?.subHeading
                                            ?.fontWeight,
                                        "",
                                      )),
                                      decoration: getTextDecoration(
                                          valueOrDefault<String>(
                                        paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.styleForText
                                            ?.typography
                                            ?.subHeading
                                            ?.textDecoration,
                                        "",
                                      )),
                                      lineHeight: 2,
                                    ),
                              )),
                        ],
                      ),
                      Padding(
                        padding: EdgeInsetsDirectional.fromSTEB(0, 30, 0, 30),
                        child: Row(
                          mainAxisSize: MainAxisSize.max,
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          crossAxisAlignment: CrossAxisAlignment.end,
                          children: [
                            Expanded(
                              child: InkWell(
                                onTap: () {
                                  typeOfPurchase[0] = (paywallconfigResponse
                                          .data
                                          ?.configuration
                                          ?.mobile
                                          ?.json
                                          ?.slotData
                                          ?.slot
                                          ?.contentDivBtn
                                          ?.value ??
                                      "");
                                  print("typeOfPurchase = Content");
                                  isContentButton = true;
                                  isPassButton = false;
                                  isSubscribeButton = false;
                                  setState(() {});
                                },
                                child: Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0, 0, 5, 0),
                                  child: Container(
                                    width:
                                        MediaQuery.of(context).size.width * 1.0,
                                    height: MediaQuery.of(context).size.height *
                                        0.2,
                                    decoration: BoxDecoration(),
                                    child: Container(
                                      width: double.infinity,
                                      height: double.infinity,
                                      child: Stack(
                                        children: [
                                          Padding(
                                            padding:
                                                EdgeInsetsDirectional.fromSTEB(
                                                    0, 10, 0, 0),
                                            child: Container(
                                              width: MediaQuery.of(context)
                                                      .size
                                                      .width *
                                                  1.0,
                                              height: MediaQuery.of(context)
                                                      .size
                                                      .height *
                                                  1,
                                              decoration: BoxDecoration(
                                                color: colorFromCssString(
                                                    valueOrDefault<String>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForBackground
                                                      ?.border
                                                      ?.contentDivBtn
                                                      ?.backgroundColor,
                                                  '#000000',
                                                )),
                                                borderRadius:
                                                    BorderRadius.circular(
                                                        valueOrDefault<double>(
                                                  paywallconfigResponse
                                                      .data
                                                      ?.configuration
                                                      ?.mobile
                                                      ?.json
                                                      ?.styleForBackground
                                                      ?.border
                                                      ?.contentDivBtn
                                                      ?.radius
                                                      ?.toDouble(),
                                                  0,
                                                )),
                                                border: isContentButton
                                                    ? Border.all(
                                                        color: Colors.blue,
                                                        width: valueOrDefault<
                                                            double>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForBackground
                                                              ?.border
                                                              ?.contentDivBtn
                                                              ?.borderWidthValue
                                                              ?.toDouble(),
                                                          0,
                                                        ),
                                                      )
                                                    : Border.all(
                                                        color:
                                                            colorFromCssString(
                                                                valueOrDefault<
                                                                    String>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForBackground
                                                              ?.border
                                                              ?.contentDivBtn
                                                              ?.borderColor,
                                                          '#000000',
                                                        )),
                                                        width: valueOrDefault<
                                                            double>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForBackground
                                                              ?.border
                                                              ?.contentDivBtn
                                                              ?.borderWidthValue
                                                              ?.toDouble(),
                                                          0,
                                                        ),
                                                      ),
                                              ),
                                              child: SingleChildScrollView(
                                                child: Column(
                                                  mainAxisSize:
                                                      MainAxisSize.max,
                                                  mainAxisAlignment:
                                                      MainAxisAlignment
                                                          .spaceBetween,
                                                  children: [
                                                    Container(
                                                      width:
                                                          MediaQuery.of(context)
                                                              .size
                                                              .width,
                                                      height:
                                                          MediaQuery.of(context)
                                                                  .size
                                                                  .height *
                                                              0.05,
                                                      decoration: BoxDecoration(
                                                        color:
                                                            colorFromCssString(
                                                                valueOrDefault<
                                                                    String>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForBackground
                                                              ?.border
                                                              ?.contentHeader
                                                              ?.backgroundColor,
                                                          '#FFFFFF',
                                                        )),
                                                        border: Border.all(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentHeader
                                                                ?.borderColor,
                                                            '#000000',
                                                          )),
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentHeader
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        ),
                                                        borderRadius:
                                                            BorderRadius.only(
                                                          bottomLeft:
                                                              const Radius
                                                                  .circular(0),
                                                          bottomRight:
                                                              const Radius
                                                                  .circular(0),
                                                          topLeft:
                                                              Radius.circular(
                                                                  valueOrDefault<
                                                                      double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentHeader
                                                                ?.radius
                                                                ?.toDouble(),
                                                            0,
                                                          )),
                                                          topRight:
                                                              Radius.circular(
                                                                  valueOrDefault<
                                                                      double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.contentHeader
                                                                ?.radius
                                                                ?.toDouble(),
                                                            0,
                                                          )),
                                                        ),
                                                      ),
                                                      child: Align(
                                                        alignment:
                                                            const AlignmentDirectional(
                                                                0, 0),
                                                        child: Padding(
                                                          padding:
                                                              const EdgeInsetsDirectional
                                                                      .fromSTEB(
                                                                  0, 5, 0, 2),
                                                          child: AutoSizeText(
                                                            getTextWithTransform(
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.contentHeader
                                                                    ?.text,
                                                                'Day Pass',
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.contentHeader
                                                                    ?.textTransform),
                                                            textAlign:
                                                                getTextAlign(
                                                                    valueOrDefault<
                                                                        String>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.contentHeader
                                                                  ?.textAlign,
                                                              '',
                                                            )),
                                                            style: FlutterFlowTheme
                                                                    .of(context)
                                                                .bodyText1
                                                                .override(
                                                                    fontWeight: getFontWeight(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentHeader
                                                                          ?.fontWeight,
                                                                      "",
                                                                    )),
                                                                    fontFamily:
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentHeader
                                                                          ?.fontFamily,
                                                                      'Roboto',
                                                                    ),
                                                                    color: colorFromCssString(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentHeader
                                                                          ?.color,
                                                                      '#0164B1',
                                                                    )),
                                                                    decoration:
                                                                        getTextDecoration(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentHeader
                                                                          ?.textDecoration,
                                                                      "",
                                                                    ))),
                                                          ),
                                                        ),
                                                      ),
                                                    ),
                                                    Padding(
                                                      padding:
                                                          const EdgeInsetsDirectional
                                                                  .fromSTEB(
                                                              0, 12, 0, 0),
                                                      child: AutoSizeText(
                                                        getTextWithTransform(
                                                            "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.contentDivPrice?.text} ${Constants.contentPrice}",
                                                            'RS 999',
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.contentDivPrice
                                                                ?.textTransform),
                                                        textAlign: getTextAlign(
                                                            valueOrDefault<
                                                                String>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForText
                                                              ?.typography
                                                              ?.subHeading
                                                              ?.textAlign,
                                                          '',
                                                        )),
                                                        style:
                                                            FlutterFlowTheme.of(
                                                                    context)
                                                                .bodyText1
                                                                .override(
                                                                  fontWeight: getFontWeight(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivPrice
                                                                        ?.fontWeight,
                                                                    "",
                                                                  )),
                                                                  fontFamily:
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivPrice
                                                                        ?.fontFamily,
                                                                    'Roboto',
                                                                  ),
                                                                  color: colorFromCssString(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivPrice
                                                                        ?.color,
                                                                    '#ffffff',
                                                                  )),
                                                                  decoration: getTextDecoration(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivPrice
                                                                        ?.textDecoration,
                                                                    "",
                                                                  )),
                                                                  fontSize: 16,
                                                                ),
                                                      ),
                                                    ),
                                                    Padding(
                                                      padding:
                                                          const EdgeInsetsDirectional
                                                                  .fromSTEB(
                                                              12, 8, 12, 0),
                                                      child: Row(
                                                        mainAxisSize:
                                                            MainAxisSize.max,
                                                        mainAxisAlignment:
                                                            MainAxisAlignment
                                                                .center,
                                                        children: [
                                                          Expanded(
                                                            child: Text(
                                                              getTextWithTransform(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivCutPrice
                                                                      ?.text,
                                                                  '50% off',
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivCutPrice
                                                                      ?.textTransform),
                                                              textAlign: getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.contentDivCutPrice
                                                                    ?.textAlign,
                                                                '',
                                                              )),
                                                              style: FlutterFlowTheme
                                                                      .of(context)
                                                                  .bodyText1
                                                                  .override(
                                                                    fontWeight:
                                                                        getFontWeight(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivCutPrice
                                                                          ?.fontWeight,
                                                                      "200",
                                                                    )),
                                                                    fontFamily:
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivCutPrice
                                                                          ?.fontFamily,
                                                                      'Roboto',
                                                                    ),
                                                                    color: colorFromCssString(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivCutPrice
                                                                          ?.color,
                                                                      '#ffffff',
                                                                    )),
                                                                    decoration:
                                                                        getTextDecoration(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivCutPrice
                                                                          ?.textDecoration,
                                                                      "",
                                                                    )),
                                                                    fontSize:
                                                                        10,
                                                                  ),
                                                            ),
                                                          ),
                                                          Expanded(
                                                            child: Text(
                                                              getTextWithTransform(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivSymbolPrice
                                                                      ?.text,
                                                                  '@₹80',
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.contentDivSymbolPrice
                                                                      ?.textTransform),
                                                              textAlign: getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.contentDivSymbolPrice
                                                                    ?.textAlign,
                                                                '',
                                                              )),
                                                              style: FlutterFlowTheme
                                                                      .of(context)
                                                                  .bodyText1
                                                                  .override(
                                                                    fontWeight:
                                                                        getFontWeight(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivSymbolPrice
                                                                          ?.fontWeight,
                                                                      "200",
                                                                    )),
                                                                    fontFamily:
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivSymbolPrice
                                                                          ?.fontFamily,
                                                                      'Roboto',
                                                                    ),
                                                                    color: colorFromCssString(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivSymbolPrice
                                                                          ?.color,
                                                                      '#ffffff',
                                                                    )),
                                                                    decoration:
                                                                        getTextDecoration(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.contentDivSymbolPrice
                                                                          ?.textDecoration,
                                                                      "",
                                                                    )),
                                                                    fontSize:
                                                                        10,
                                                                  ),
                                                            ),
                                                          ),
                                                        ],
                                                      ),
                                                    ),
                                                    Padding(
                                                      padding:
                                                          const EdgeInsetsDirectional
                                                                  .fromSTEB(
                                                              0, 10, 0, 5),
                                                      child: AutoSizeText(
                                                        getTextWithTransform(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.contentDivDiscription
                                                                ?.text,
                                                            '24 hours unlimited access',
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.contentDivDiscription
                                                                ?.textTransform),
                                                        textAlign: getTextAlign(
                                                            valueOrDefault<
                                                                String>(
                                                          paywallconfigResponse
                                                              .data
                                                              ?.configuration
                                                              ?.mobile
                                                              ?.json
                                                              ?.styleForText
                                                              ?.typography
                                                              ?.contentDivDiscription
                                                              ?.textAlign,
                                                          '',
                                                        )),
                                                        style:
                                                            FlutterFlowTheme.of(
                                                                    context)
                                                                .bodyText1
                                                                .override(
                                                                  fontWeight: getFontWeight(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivDiscription
                                                                        ?.fontWeight,
                                                                    "300",
                                                                  )),
                                                                  fontFamily:
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivDiscription
                                                                        ?.fontFamily,
                                                                    'Roboto',
                                                                  ),
                                                                  color: colorFromCssString(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivDiscription
                                                                        ?.color,
                                                                    '#ffffff',
                                                                  )),
                                                                  decoration: getTextDecoration(
                                                                      valueOrDefault<
                                                                          String>(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.contentDivDiscription
                                                                        ?.textDecoration,
                                                                    "",
                                                                  )),
                                                                  fontSize: 10,
                                                                ),
                                                      ),
                                                    ),
                                                  ],
                                                ),
                                              ),
                                            ),
                                          ),
                                          if (false)
                                            Align(
                                              alignment: AlignmentDirectional(
                                                  0.05, -1),
                                              child: FFButtonWidget(
                                                onPressed: () {
                                                  print('Button pressed ...');
                                                },
                                                text: 'Recommended',
                                                options: FFButtonOptions(
                                                  width: 80,
                                                  height: 20,
                                                  color: Color(0xFFB52C2C),
                                                  textStyle: FlutterFlowTheme
                                                          .of(context)
                                                      .subtitle2
                                                      .override(
                                                        fontFamily: 'Roboto',
                                                        color: Colors.white,
                                                        fontSize: 8,
                                                        fontWeight:
                                                            FontWeight.normal,
                                                      ),
                                                  borderSide: BorderSide(
                                                    color: Colors.transparent,
                                                    width: 1,
                                                  ),
                                                  borderRadius:
                                                      BorderRadius.circular(10),
                                                ),
                                              ),
                                            ),
                                        ],
                                      ),
                                    ),
                                  ),
                                ),
                              ),
                            ),
                            if (paywallconfigResponse.data?.configuration
                                        ?.mobile?.templateId?.numberOfCta ==
                                    2 ||
                                paywallconfigResponse.data?.configuration
                                        ?.mobile?.templateId?.numberOfCta ==
                                    3)
                              Expanded(
                                child: InkWell(
                                  onTap: () {
                                    typeOfPurchase[0] = (paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.slotData
                                            ?.slot
                                            ?.passDivBtn
                                            ?.value ??
                                        "");
                                    typeOfPurchase[1] = (paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.slotData
                                            ?.slot
                                            ?.contentDivBtn
                                            ?.url ??
                                        "");
                                    print("typeOfPurchase = PASS");
                                    isContentButton = false;
                                    isPassButton = true;
                                    isSubscribeButton = false;
                                    setState(() {});
                                  },
                                  child: Padding(
                                    padding: EdgeInsetsDirectional.fromSTEB(
                                        0, 0, 5, 0),
                                    child: Container(
                                      width: MediaQuery.of(context).size.width *
                                          1.0,
                                      height:
                                          MediaQuery.of(context).size.height *
                                              0.2,
                                      decoration: BoxDecoration(),
                                      child: Container(
                                        width: double.infinity,
                                        height: double.infinity,
                                        child: Stack(
                                          children: [
                                            Padding(
                                              padding: EdgeInsetsDirectional
                                                  .fromSTEB(0, 10, 0, 0),
                                              child: Container(
                                                width: MediaQuery.of(context)
                                                        .size
                                                        .width *
                                                    1.0,
                                                height: MediaQuery.of(context)
                                                        .size
                                                        .height *
                                                    1,
                                                decoration: BoxDecoration(
                                                  color: colorFromCssString(
                                                      valueOrDefault<String>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.passDivBtn
                                                        ?.backgroundColor,
                                                    '#000000',
                                                  )),
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          valueOrDefault<
                                                              double>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.passDivBtn
                                                        ?.radius
                                                        ?.toDouble(),
                                                    0,
                                                  )),
                                                  border: isPassButton
                                                      ? Border.all(
                                                          color: Colors.blue,
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.passDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        )
                                                      : Border.all(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.passDivBtn
                                                                ?.borderColor,
                                                            '#000000',
                                                          )),
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.passDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        ),
                                                ),
                                                child: SingleChildScrollView(
                                                  child: Column(
                                                    mainAxisSize:
                                                        MainAxisSize.max,
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .spaceBetween,
                                                    children: [
                                                      Container(
                                                        width: MediaQuery.of(
                                                                context)
                                                            .size
                                                            .width,
                                                        height: MediaQuery.of(
                                                                    context)
                                                                .size
                                                                .height *
                                                            0.05,
                                                        decoration:
                                                            BoxDecoration(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.passHeader
                                                                ?.backgroundColor,
                                                            '#ffffff',
                                                          )),
                                                          border: Border.all(
                                                            color: colorFromCssString(
                                                                valueOrDefault<
                                                                    String>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passHeader
                                                                  ?.borderColor,
                                                              '#000000',
                                                            )),
                                                            width:
                                                                valueOrDefault<
                                                                    double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passHeader
                                                                  ?.borderWidthValue
                                                                  ?.toDouble(),
                                                              0,
                                                            ),
                                                          ),
                                                          borderRadius:
                                                              BorderRadius.only(
                                                            bottomLeft:
                                                                const Radius
                                                                    .circular(0),
                                                            bottomRight:
                                                                const Radius
                                                                    .circular(0),
                                                            topLeft:
                                                                Radius.circular(
                                                                    valueOrDefault<
                                                                        double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passHeader
                                                                  ?.radius
                                                                  ?.toDouble(),
                                                              0,
                                                            )),
                                                            topRight:
                                                                Radius.circular(
                                                                    valueOrDefault<
                                                                        double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.passHeader
                                                                  ?.radius
                                                                  ?.toDouble(),
                                                              0,
                                                            )),
                                                          ),
                                                        ),
                                                        child: Align(
                                                          alignment:
                                                              const AlignmentDirectional(
                                                                  0, 0),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsetsDirectional
                                                                        .fromSTEB(
                                                                    0, 5, 0, 2),
                                                            child: AutoSizeText(
                                                              getTextWithTransform(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passHeader
                                                                      ?.text,
                                                                  'Weekly Pass',
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passHeader
                                                                      ?.textTransform),
                                                              textAlign: getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.passHeader
                                                                    ?.textAlign,
                                                                '',
                                                              )),
                                                              style: FlutterFlowTheme
                                                                      .of(context)
                                                                  .bodyText1
                                                                  .override(
                                                                    fontWeight:
                                                                        getFontWeight(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.passHeader
                                                                          ?.fontWeight,
                                                                      "",
                                                                    )),
                                                                    fontFamily:
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.passHeader
                                                                          ?.fontFamily,
                                                                      'Roboto',
                                                                    ),
                                                                    color: colorFromCssString(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.passHeader
                                                                          ?.color,
                                                                      '#0164B1',
                                                                    )),
                                                                    decoration:
                                                                        getTextDecoration(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.passHeader
                                                                          ?.textDecoration,
                                                                      "",
                                                                    )),
                                                                  ),
                                                            ),
                                                          ),
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            EdgeInsetsDirectional
                                                                .fromSTEB(0, 12,
                                                                    0, 0),
                                                        child: AutoSizeText(
                                                          getTextWithTransform(
                                                              "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.passDivPrice?.text} ${Constants.passPrice}",
                                                              'RS 999',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.passDivPrice
                                                                  ?.textTransform),
                                                          textAlign:
                                                              getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.passDivPrice
                                                                ?.textAlign,
                                                            '',
                                                          )),
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivPrice
                                                                      ?.fontWeight,
                                                                  "",
                                                                )),
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivPrice
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivPrice
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivPrice
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 16,
                                                              ),
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            const EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                12, 8, 12, 0),
                                                        child: Row(
                                                          mainAxisSize:
                                                              MainAxisSize.max,
                                                          mainAxisAlignment:
                                                              MainAxisAlignment
                                                                  .center,
                                                          children: [
                                                            Expanded(
                                                              child: Text(
                                                                getTextWithTransform(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivCutPrice
                                                                        ?.text,
                                                                    '50% off',
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivCutPrice
                                                                        ?.textTransform),
                                                                textAlign: getTextAlign(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivCutPrice
                                                                      ?.textAlign,
                                                                  '',
                                                                )),
                                                                style: FlutterFlowTheme.of(
                                                                        context)
                                                                    .bodyText1
                                                                    .override(
                                                                      fontWeight:
                                                                          getFontWeight(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivCutPrice
                                                                            ?.fontWeight,
                                                                        "200",
                                                                      )),
                                                                      fontFamily:
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivCutPrice
                                                                            ?.fontFamily,
                                                                        'Roboto',
                                                                      ),
                                                                      color: colorFromCssString(
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivCutPrice
                                                                            ?.color,
                                                                        '#ffffff',
                                                                      )),
                                                                      decoration:
                                                                          getTextDecoration(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivCutPrice
                                                                            ?.textDecoration,
                                                                        "",
                                                                      )),
                                                                      fontSize:
                                                                          10,
                                                                    ),
                                                              ),
                                                            ),
                                                            Expanded(
                                                              child: Text(
                                                                getTextWithTransform(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivSymbolCutPrice
                                                                        ?.text,
                                                                    '@80',
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.passDivSymbolCutPrice
                                                                        ?.textTransform),
                                                                textAlign: getTextAlign(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivSymbolCutPrice
                                                                      ?.textAlign,
                                                                  '',
                                                                )),
                                                                style: FlutterFlowTheme.of(
                                                                        context)
                                                                    .bodyText1
                                                                    .override(
                                                                      fontWeight:
                                                                          getFontWeight(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivSymbolCutPrice
                                                                            ?.fontWeight,
                                                                        "200",
                                                                      )),
                                                                      fontFamily:
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivSymbolCutPrice
                                                                            ?.fontFamily,
                                                                        'Roboto',
                                                                      ),
                                                                      color: colorFromCssString(
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivSymbolCutPrice
                                                                            ?.color,
                                                                        '#ffffff',
                                                                      )),
                                                                      decoration:
                                                                          getTextDecoration(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.passDivSymbolCutPrice
                                                                            ?.textDecoration,
                                                                        "",
                                                                      )),
                                                                      fontSize:
                                                                          10,
                                                                    ),
                                                              ),
                                                            ),
                                                          ],
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            const EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                0, 10, 0, 5),
                                                        child: AutoSizeText(
                                                          getTextWithTransform(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.passDivDiscription
                                                                  ?.text,
                                                              '7 Days unlimited premium stories access',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.passDivDiscription
                                                                  ?.textTransform),
                                                          textAlign:
                                                              getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.passDivDiscription
                                                                ?.textAlign,
                                                            '',
                                                          )),
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivDiscription
                                                                      ?.fontWeight,
                                                                  "300",
                                                                )),
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivDiscription
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivDiscription
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.passDivDiscription
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 10,
                                                              ),
                                                        ),
                                                      ),
                                                    ],
                                                  ),
                                                ),
                                              ),
                                            ),
                                            if (false)
                                              Align(
                                                alignment: AlignmentDirectional(
                                                    0.05, -1),
                                                child: FFButtonWidget(
                                                  onPressed: () {
                                                    print('Button pressed ...');
                                                  },
                                                  text: 'Recommended',
                                                  options: FFButtonOptions(
                                                    width: 80,
                                                    height: 20,
                                                    color: Color(0xFFB52C2C),
                                                    textStyle: FlutterFlowTheme
                                                            .of(context)
                                                        .subtitle2
                                                        .override(
                                                          fontFamily: 'Roboto',
                                                          color: Colors.white,
                                                          fontSize: 8,
                                                          fontWeight:
                                                              FontWeight.normal,
                                                        ),
                                                    borderSide: BorderSide(
                                                      color: Colors.transparent,
                                                      width: 1,
                                                    ),
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            10),
                                                  ),
                                                ),
                                              ),
                                          ],
                                        ),
                                      ),
                                    ),
                                  ),
                                ),
                              ),
                            if (paywallconfigResponse.data?.configuration
                                    ?.mobile?.templateId?.numberOfCta ==
                                3)
                              Expanded(
                                child: InkWell(
                                  onTap: () {
                                    typeOfPurchase.first =
                                        (paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.slotData
                                                ?.slot
                                                ?.subDivBtn
                                                ?.value ??
                                            "");
                                    typeOfPurchase[1] = (paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.slotData
                                            ?.slot
                                            ?.subDivBtn
                                            ?.url ??
                                        "");
                                    print("typeOfPurchase = SUBS");
                                    isContentButton = false;
                                    isPassButton = false;
                                    isSubscribeButton = true;
                                    setState(() {});
                                  },
                                  child: Padding(
                                    padding: EdgeInsetsDirectional.fromSTEB(
                                        0, 0, 5, 0),
                                    child: Container(
                                      width: MediaQuery.of(context).size.width *
                                          1.0,
                                      height:
                                          MediaQuery.of(context).size.height *
                                              0.2,
                                      decoration: BoxDecoration(),
                                      child: Container(
                                        width: double.infinity,
                                        height: double.infinity,
                                        child: Stack(
                                          children: [
                                            Padding(
                                              padding: EdgeInsetsDirectional
                                                  .fromSTEB(0, 10, 0, 0),
                                              child: Container(
                                                width: MediaQuery.of(context)
                                                        .size
                                                        .width *
                                                    1.0,
                                                height: MediaQuery.of(context)
                                                        .size
                                                        .height *
                                                    1,
                                                decoration: BoxDecoration(
                                                  color: colorFromCssString(
                                                      valueOrDefault<String>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.subDivBtn
                                                        ?.backgroundColor,
                                                    '#000000',
                                                  )),
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          valueOrDefault<
                                                              double>(
                                                    paywallconfigResponse
                                                        .data
                                                        ?.configuration
                                                        ?.mobile
                                                        ?.json
                                                        ?.styleForBackground
                                                        ?.border
                                                        ?.subDivBtn
                                                        ?.radius
                                                        ?.toDouble(),
                                                    0,
                                                  )),
                                                  border: isSubscribeButton
                                                      ? Border.all(
                                                          color: Colors.blue,
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.subDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        )
                                                      : Border.all(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.subDivBtn
                                                                ?.borderColor,
                                                            '#000000',
                                                          )),
                                                          width: valueOrDefault<
                                                              double>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.subDivBtn
                                                                ?.borderWidthValue
                                                                ?.toDouble(),
                                                            0,
                                                          ),
                                                        ),
                                                ),
                                                child: SingleChildScrollView(
                                                  child: Column(
                                                    mainAxisSize:
                                                        MainAxisSize.max,
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .spaceBetween,
                                                    children: [
                                                      Container(
                                                        width: MediaQuery.of(
                                                                context)
                                                            .size
                                                            .width,
                                                        height: MediaQuery.of(
                                                                    context)
                                                                .size
                                                                .height *
                                                            0.05,
                                                        decoration:
                                                            BoxDecoration(
                                                          color:
                                                              colorFromCssString(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForBackground
                                                                ?.border
                                                                ?.subscriptionHeader
                                                                ?.backgroundColor,
                                                            '#ffffff',
                                                          )),
                                                          border: Border.all(
                                                            color: colorFromCssString(
                                                                valueOrDefault<
                                                                    String>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.subscriptionHeader
                                                                  ?.borderColor,
                                                              '#000000',
                                                            )),
                                                            width:
                                                                valueOrDefault<
                                                                    double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.subscriptionHeader
                                                                  ?.borderWidthValue
                                                                  ?.toDouble(),
                                                              0,
                                                            ),
                                                          ),
                                                          borderRadius:
                                                              BorderRadius.only(
                                                            bottomLeft:
                                                                const Radius
                                                                    .circular(0),
                                                            bottomRight:
                                                                const Radius
                                                                    .circular(0),
                                                            topLeft:
                                                                Radius.circular(
                                                                    valueOrDefault<
                                                                        double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.subscriptionHeader
                                                                  ?.radius
                                                                  ?.toDouble(),
                                                              0,
                                                            )),
                                                            topRight:
                                                                Radius.circular(
                                                                    valueOrDefault<
                                                                        double>(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForBackground
                                                                  ?.border
                                                                  ?.subscriptionHeader
                                                                  ?.radius
                                                                  ?.toDouble(),
                                                              0,
                                                            )),
                                                          ),
                                                        ),
                                                        child: Align(
                                                          alignment:
                                                              const AlignmentDirectional(
                                                                  0, 0),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsetsDirectional
                                                                        .fromSTEB(
                                                                    0, 5, 0, 2),
                                                            child: AutoSizeText(
                                                              getTextWithTransform(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subscriptionHeader
                                                                      ?.text,
                                                                  'Anually',
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subscriptionHeader
                                                                      ?.textTransform),
                                                              textAlign: getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                                paywallconfigResponse
                                                                    .data
                                                                    ?.configuration
                                                                    ?.mobile
                                                                    ?.json
                                                                    ?.styleForText
                                                                    ?.typography
                                                                    ?.subscriptionHeader
                                                                    ?.textAlign,
                                                                '',
                                                              )),
                                                              style: FlutterFlowTheme
                                                                      .of(context)
                                                                  .bodyText1
                                                                  .override(
                                                                    fontWeight:
                                                                        getFontWeight(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.subscriptionHeader
                                                                          ?.fontWeight,
                                                                      "",
                                                                    )),
                                                                    fontFamily:
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.subscriptionHeader
                                                                          ?.fontFamily,
                                                                      'Roboto',
                                                                    ),
                                                                    color: colorFromCssString(
                                                                        valueOrDefault<
                                                                            String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.subscriptionHeader
                                                                          ?.color,
                                                                      '#0164B1',
                                                                    )),
                                                                    decoration:
                                                                        getTextDecoration(
                                                                            valueOrDefault<String>(
                                                                      paywallconfigResponse
                                                                          .data
                                                                          ?.configuration
                                                                          ?.mobile
                                                                          ?.json
                                                                          ?.styleForText
                                                                          ?.typography
                                                                          ?.subscriptionHeader
                                                                          ?.textDecoration,
                                                                      "",
                                                                    )),
                                                                  ),
                                                            ),
                                                          ),
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            EdgeInsetsDirectional
                                                                .fromSTEB(0, 12,
                                                                    0, 0),
                                                        child: AutoSizeText(
                                                          getTextWithTransform(
                                                              "${paywallconfigResponse.data?.configuration?.mobile?.json?.styleForText?.typography?.subDivPrice?.text} ${Constants.subscriptionPrice}",
                                                              'RS 999',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.subDivPrice
                                                                  ?.textTransform),
                                                          textAlign:
                                                              getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivPrice
                                                                ?.textAlign,
                                                            '',
                                                          )),
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.fontWeight,
                                                                  "",
                                                                )),
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivPrice
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 16,
                                                              ),
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            const EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                12, 8, 12, 0),
                                                        child: Row(
                                                          mainAxisSize:
                                                              MainAxisSize.max,
                                                          mainAxisAlignment:
                                                              MainAxisAlignment
                                                                  .center,
                                                          children: [
                                                            Expanded(
                                                              child: Text(
                                                                getTextWithTransform(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.subscriptionDivCutPrice
                                                                        ?.text,
                                                                    '50% off',
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.subscriptionDivCutPrice
                                                                        ?.textTransform),
                                                                textAlign: getTextAlign(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subscriptionDivCutPrice
                                                                      ?.textAlign,
                                                                  '',
                                                                )),
                                                                style: FlutterFlowTheme.of(
                                                                        context)
                                                                    .bodyText1
                                                                    .override(
                                                                      fontWeight:
                                                                          getFontWeight(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivCutPrice
                                                                            ?.fontWeight,
                                                                        "200",
                                                                      )),
                                                                      fontFamily:
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivCutPrice
                                                                            ?.fontFamily,
                                                                        'Roboto',
                                                                      ),
                                                                      color: colorFromCssString(
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivCutPrice
                                                                            ?.color,
                                                                        '#ffffff',
                                                                      )),
                                                                      decoration:
                                                                          getTextDecoration(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivCutPrice
                                                                            ?.textDecoration,
                                                                        "",
                                                                      )),
                                                                      fontSize:
                                                                          10,
                                                                    ),
                                                              ),
                                                            ),
                                                            Expanded(
                                                              child: Text(
                                                                getTextWithTransform(
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.subscriptionDivSymbolPrice
                                                                        ?.text,
                                                                    '@80',
                                                                    paywallconfigResponse
                                                                        .data
                                                                        ?.configuration
                                                                        ?.mobile
                                                                        ?.json
                                                                        ?.styleForText
                                                                        ?.typography
                                                                        ?.subscriptionDivSymbolPrice
                                                                        ?.textTransform),
                                                                textAlign: getTextAlign(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subscriptionDivSymbolPrice
                                                                      ?.textAlign,
                                                                  '',
                                                                )),
                                                                style: FlutterFlowTheme.of(
                                                                        context)
                                                                    .bodyText1
                                                                    .override(
                                                                      fontWeight:
                                                                          getFontWeight(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivSymbolPrice
                                                                            ?.fontWeight,
                                                                        "200",
                                                                      )),
                                                                      fontFamily:
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivSymbolPrice
                                                                            ?.fontFamily,
                                                                        'Roboto',
                                                                      ),
                                                                      color: colorFromCssString(
                                                                          valueOrDefault<
                                                                              String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivSymbolPrice
                                                                            ?.color,
                                                                        '#ffffff',
                                                                      )),
                                                                      decoration:
                                                                          getTextDecoration(
                                                                              valueOrDefault<String>(
                                                                        paywallconfigResponse
                                                                            .data
                                                                            ?.configuration
                                                                            ?.mobile
                                                                            ?.json
                                                                            ?.styleForText
                                                                            ?.typography
                                                                            ?.subscriptionDivSymbolPrice
                                                                            ?.textDecoration,
                                                                        "",
                                                                      )),
                                                                      fontSize:
                                                                          10,
                                                                    ),
                                                              ),
                                                            ),
                                                          ],
                                                        ),
                                                      ),
                                                      Padding(
                                                        padding:
                                                            const EdgeInsetsDirectional
                                                                    .fromSTEB(
                                                                0, 10, 0, 5),
                                                        child: AutoSizeText(
                                                          getTextWithTransform(
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.subDivDiscription
                                                                  ?.text,
                                                              'Enjoy Premium stories for 365 days',
                                                              paywallconfigResponse
                                                                  .data
                                                                  ?.configuration
                                                                  ?.mobile
                                                                  ?.json
                                                                  ?.styleForText
                                                                  ?.typography
                                                                  ?.subDivDiscription
                                                                  ?.textTransform),
                                                          textAlign:
                                                              getTextAlign(
                                                                  valueOrDefault<
                                                                      String>(
                                                            paywallconfigResponse
                                                                .data
                                                                ?.configuration
                                                                ?.mobile
                                                                ?.json
                                                                ?.styleForText
                                                                ?.typography
                                                                ?.subDivDiscription
                                                                ?.textAlign,
                                                            '',
                                                          )),
                                                          style: FlutterFlowTheme
                                                                  .of(context)
                                                              .bodyText1
                                                              .override(
                                                                fontWeight: getFontWeight(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivDiscription
                                                                      ?.fontWeight,
                                                                  "300",
                                                                )),
                                                                fontFamily:
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivDiscription
                                                                      ?.fontFamily,
                                                                  'Roboto',
                                                                ),
                                                                color: colorFromCssString(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivDiscription
                                                                      ?.color,
                                                                  '#ffffff',
                                                                )),
                                                                decoration: getTextDecoration(
                                                                    valueOrDefault<
                                                                        String>(
                                                                  paywallconfigResponse
                                                                      .data
                                                                      ?.configuration
                                                                      ?.mobile
                                                                      ?.json
                                                                      ?.styleForText
                                                                      ?.typography
                                                                      ?.subDivDiscription
                                                                      ?.textDecoration,
                                                                  "",
                                                                )),
                                                                fontSize: 10,
                                                              ),
                                                        ),
                                                      ),
                                                    ],
                                                  ),
                                                ),
                                              ),
                                            ),
                                            if (false)
                                              Align(
                                                alignment: AlignmentDirectional(
                                                    0.05, -1),
                                                child: FFButtonWidget(
                                                  onPressed: () {
                                                    print('Button pressed ...');
                                                  },
                                                  text: 'Recommended',
                                                  options: FFButtonOptions(
                                                    width: 80,
                                                    height: 20,
                                                    color: Color(0xFFB52C2C),
                                                    textStyle: FlutterFlowTheme
                                                            .of(context)
                                                        .subtitle2
                                                        .override(
                                                          fontFamily: 'Roboto',
                                                          color: Colors.white,
                                                          fontSize: 8,
                                                          fontWeight:
                                                              FontWeight.normal,
                                                        ),
                                                    borderSide: BorderSide(
                                                      color: Colors.transparent,
                                                      width: 1,
                                                    ),
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            10),
                                                  ),
                                                ),
                                              ),
                                          ],
                                        ),
                                      ),
                                    ),
                                  ),
                                ),
                              ),
                          ],
                        ),
                      ),
                      if (functions.conscentBalanceVisibilty())
                        Padding(
                          padding:
                              const EdgeInsetsDirectional.fromSTEB(0, 30, 0, 0),
                          child: Text(
                            getTextWithTransform(
                                'ConsCent Balance: ₹${Constants.conscentBalance}',
                                "ConsCent Balance: ₹0",
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForText
                                    ?.typography
                                    ?.conscentBalance
                                    ?.textTransform),
                            style: FlutterFlowTheme.of(context)
                                .bodyText1
                                .override(
                                  fontFamily: valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.conscentBalance
                                        ?.fontFamily,
                                    'Roboto',
                                  ),
                                  color:
                                      colorFromCssString(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.conscentBalance
                                        ?.color,
                                    '#ffffff',
                                  )),
                                  decoration:
                                      getTextDecoration(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.conscentBalance
                                        ?.textDecoration,
                                    "",
                                  )),
                                  fontWeight:
                                      getFontWeight(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.conscentBalance
                                        ?.fontWeight,
                                    "600",
                                  )),
                                ),
                          ),
                        ),
                      Padding(
                        padding:
                            const EdgeInsetsDirectional.fromSTEB(0, 5, 0, 10),
                        child: FFButtonWidget(
                          onPressed: () async {
                            print('Button pressed ...');
                            print(
                                "typeOfPurchase ${typeOfPurchase.first} ${typeOfPurchase.last}");
                            String redirectUrl = await ConscentMethods()
                                .prepareLoginChallenge(typeOfPurchase);

                            if (typeOfPurchase[0] == "subscription") {
                              ConscentMethods().paywallClickEvent("SUBS");
                            } else {
                              if (typeOfPurchase[0] == "" ||
                                  typeOfPurchase[0] == null) {
                                ConscentMethods().paywallClickEvent("CONTENT");
                              } else {
                                ConscentMethods().paywallClickEvent(
                                    typeOfPurchase[0].toUpperCase());
                              }
                            }

                            Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (context) => WebViewDefaultApp(
                                      redirectUrl: redirectUrl),
                                )).then((value) {
                              if (value != null) {
                                dynamic response = value['response'];
                                widget.sessionCallback(response);
                              }
                            });
                          },
                          text: getTextWithTransform(
                              paywallconfigResponse
                                  .data
                                  ?.configuration
                                  ?.mobile
                                  ?.json
                                  ?.styleForText
                                  ?.typography
                                  ?.mainSubmitBtn
                                  ?.text,
                              'Subscribe',
                              paywallconfigResponse
                                  .data
                                  ?.configuration
                                  ?.mobile
                                  ?.json
                                  ?.styleForText
                                  ?.typography
                                  ?.mainSubmitBtn
                                  ?.textTransform),
                          options: FFButtonOptions(
                            width: 346.5,
                            height: 59.7,
                            color: colorFromCssString(valueOrDefault<String>(
                              paywallconfigResponse
                                  .data
                                  ?.configuration
                                  ?.mobile
                                  ?.json
                                  ?.styleForBackground
                                  ?.border
                                  ?.mainSubmitBtn
                                  ?.backgroundColor,
                              '#0164B1',
                            )),
                            textStyle: FlutterFlowTheme.of(context)
                                .subtitle2
                                .override(
                                  fontFamily: valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.mainSubmitBtn
                                        ?.fontFamily,
                                    'Roboto',
                                  ),
                                  decoration:
                                      getTextDecoration(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.mainSubmitBtn
                                        ?.textDecoration,
                                    "",
                                  )),
                                  color:
                                      colorFromCssString(valueOrDefault<String>(
                                    paywallconfigResponse
                                        .data
                                        ?.configuration
                                        ?.mobile
                                        ?.json
                                        ?.styleForText
                                        ?.typography
                                        ?.mainSubmitBtn
                                        ?.color,
                                    '#ffffff',
                                  )),
                                ),
                            borderSide: BorderSide(
                              color: colorFromCssString(valueOrDefault<String>(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForBackground
                                    ?.border
                                    ?.mainSubmitBtn
                                    ?.borderColor,
                                '#0164B1',
                              )),
                              width: valueOrDefault<double>(
                                paywallconfigResponse
                                    .data
                                    ?.configuration
                                    ?.mobile
                                    ?.json
                                    ?.styleForBackground
                                    ?.border
                                    ?.mainSubmitBtn
                                    ?.borderWidthValue
                                    ?.toDouble(),
                                0,
                              ),
                            ),
                            borderRadius:
                                BorderRadius.circular(valueOrDefault<double>(
                              paywallconfigResponse
                                  .data
                                  ?.configuration
                                  ?.mobile
                                  ?.json
                                  ?.styleForBackground
                                  ?.border
                                  ?.mainSubmitBtn
                                  ?.radius
                                  ?.toDouble(),
                              0,
                            )),
                          ),
                        ),
                      ),
                      Align(
                        alignment: AlignmentDirectional(-0.05, 0),
                        child: Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(0, 10, 0, 20),
                          child: Column(
                            mainAxisSize: MainAxisSize.max,
                            mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                            children: [
                              Row(
                                mainAxisSize: MainAxisSize.max,
                                mainAxisAlignment: MainAxisAlignment.center,
                                children: [
                                  Text(
                                    getTextWithTransform(
                                        'Have a coupon code? ',
                                        'Have a coupon code? ',
                                        paywallconfigResponse
                                            .data
                                            ?.configuration
                                            ?.mobile
                                            ?.json
                                            ?.styleForText
                                            ?.typography
                                            ?.couponLeftText
                                            ?.textTransform),
                                    style: FlutterFlowTheme.of(context)
                                        .bodyText1
                                        .override(
                                          fontFamily: valueOrDefault<String>(
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.couponLeftText
                                                ?.fontFamily,
                                            'Roboto',
                                          ),
                                          color: colorFromCssString(
                                              valueOrDefault<String>(
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.couponLeftText
                                                ?.color,
                                            '#ffffff',
                                          )),
                                          decoration: getTextDecoration(
                                              valueOrDefault<String>(
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.couponLeftText
                                                ?.textDecoration,
                                            "",
                                          )),
                                          fontWeight: getFontWeight(
                                              valueOrDefault<String>(
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.couponLeftText
                                                ?.fontWeight,
                                            "",
                                          )),
                                        ),
                                  ),
                                  InkWell(
                                    onTap: () async {
                                      typeOfPurchase.first = "";
                                      String redirectUrl =
                                          await ConscentMethods()
                                              .prepareLoginChallenge(
                                                  typeOfPurchase);

                                      if (typeOfPurchase[0] == "subscription") {
                                        ConscentMethods()
                                            .paywallClickEvent("SUBS");
                                      } else {
                                        ConscentMethods().paywallClickEvent(
                                            typeOfPurchase[0].toUpperCase());
                                      }

                                      Navigator.push(
                                          context,
                                          MaterialPageRoute(
                                            builder: (context) =>
                                                WebViewDefaultApp(
                                                    redirectUrl: redirectUrl),
                                          )).then((value) {
                                        if (value != null) {
                                          dynamic response = value['response'];
                                          widget.sessionCallback(response);
                                        }
                                      });
                                    },
                                    child: Text(
                                      getTextWithTransform(
                                          'Click here',
                                          'Click here',
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.couponRightText
                                              ?.textTransform),
                                      style: FlutterFlowTheme.of(context)
                                          .bodyText1
                                          .override(
                                            fontFamily: valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.couponRightText
                                                  ?.fontFamily,
                                              'Roboto',
                                            ),
                                            color: colorFromCssString(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.couponRightText
                                                  ?.color,
                                              '#ffffff',
                                            )),
                                            fontWeight: getFontWeight(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.couponRightText
                                                  ?.fontWeight,
                                              "500",
                                            )),
                                            decoration: getTextDecoration(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.couponRightText
                                                  ?.textDecoration,
                                              "",
                                            )),
                                          ),
                                    ),
                                  )
                                ],
                              ),
                              Padding(
                                padding:
                                    EdgeInsetsDirectional.fromSTEB(0, 10, 0, 0),
                                child: Row(
                                  mainAxisSize: MainAxisSize.max,
                                  mainAxisAlignment: MainAxisAlignment.center,
                                  children: [
                                    Text(
                                      getTextWithTransform(
                                          'Already Purchased? ',
                                          'Already Purchased? ',
                                          paywallconfigResponse
                                              .data
                                              ?.configuration
                                              ?.mobile
                                              ?.json
                                              ?.styleForText
                                              ?.typography
                                              ?.alreadyLeftText
                                              ?.textTransform),
                                      style: FlutterFlowTheme.of(context)
                                          .bodyText1
                                          .override(
                                            fontFamily: valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.alreadyLeftText
                                                  ?.fontFamily,
                                              'Roboto',
                                            ),
                                            color: colorFromCssString(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.alreadyLeftText
                                                  ?.color,
                                              '#ffffff',
                                            )),
                                            fontWeight: getFontWeight(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.alreadyLeftText
                                                  ?.fontWeight,
                                              "",
                                            )),
                                            decoration: getTextDecoration(
                                                valueOrDefault<String>(
                                              paywallconfigResponse
                                                  .data
                                                  ?.configuration
                                                  ?.mobile
                                                  ?.json
                                                  ?.styleForText
                                                  ?.typography
                                                  ?.alreadyLeftText
                                                  ?.textDecoration,
                                              "",
                                            )),
                                          ),
                                    ),
                                    InkWell(
                                      onTap: () async {
                                        print('Click here pressed ...');
                                        typeOfPurchase.first = "";
                                        String redirectUrl =
                                            await ConscentMethods()
                                                .prepareLoginChallenge(
                                                    typeOfPurchase);
                                        if (typeOfPurchase[0] ==
                                            "subscription") {
                                          ConscentMethods()
                                              .paywallClickEvent("SUBS");
                                        } else {
                                          ConscentMethods().paywallClickEvent(
                                              typeOfPurchase[0].toUpperCase());
                                        }
                                        Navigator.push(
                                            context,
                                            MaterialPageRoute(
                                              builder: (context) =>
                                                  WebViewDefaultApp(
                                                      redirectUrl:
                                                          redirectUrl),
                                            )).then((value) {
                                          if (value != null) {
                                            dynamic response =
                                                value['response'];
                                            widget.sessionCallback(response);
                                          }
                                        });
                                      },
                                      child: Text(
                                        getTextWithTransform(
                                            'Login',
                                            'Login',
                                            paywallconfigResponse
                                                .data
                                                ?.configuration
                                                ?.mobile
                                                ?.json
                                                ?.styleForText
                                                ?.typography
                                                ?.loginText
                                                ?.textTransform),
                                        style: FlutterFlowTheme.of(context)
                                            .bodyText1
                                            .override(
                                              fontFamily:
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.loginText
                                                    ?.fontFamily,
                                                'Roboto',
                                              ),
                                              color: colorFromCssString(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.loginText
                                                    ?.color,
                                                '#ffffff',
                                              )),
                                              fontWeight: getFontWeight(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.loginText
                                                    ?.fontWeight,
                                                "500",
                                              )),
                                              decoration: getTextDecoration(
                                                  valueOrDefault<String>(
                                                paywallconfigResponse
                                                    .data
                                                    ?.configuration
                                                    ?.mobile
                                                    ?.json
                                                    ?.styleForText
                                                    ?.typography
                                                    ?.loginText
                                                    ?.textDecoration,
                                                "",
                                              )),
                                            ),
                                      ),
                                    )
                                  ],
                                ),
                              ),
                            ],
                          ),
                        ),
                      ),
                    ],
                  ),
                ),
              ),
            ),
          ),
        ),
      ),
    );
  }
}
